import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//**********************************************************************

class nubj_poly extends nubj

//**********************************************************************

{
    Color c;
    int n, ikk=0;
    nubj_poly(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    nubj_poly(int xxg[],int yyg[],int np,Color cc,nubj_list p)
    {
	super(p);
	int i ;
        for (i=0;i<np;i++) {
	     xg[i] = xxg[i] ;
	     yg[i] = yyg[i] ;
	     if (xmin > xg[i]) xmin  = xg[i] ;
	     if (xmax < xg[i]) xmax  = xg[i] ;
	     if (ymin > yg[i]) ymin  = yg[i] ;
	     if (ymax < yg[i]) ymax  = yg[i] ;
	     }
	n = np;
	select = 3;
	refill = 1 ;
    }

    public nubj copy(nubj_list gl)
    {
	nubj_poly g;
	g = new nubj_poly(xg[0],yg[0],c,gl);
	g.movepoint(xg[1]-xg[0],yg[1]-yg[0]);
	for(int i = 2;i<n;i++)
	    g.addpoint(xg[i],yg[i]);
	g.select = 0;
	return(g);
    }

    public void transform(double xc, double yc, double zc)
    {
	ikk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0,i;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	Polygon p = new Polygon();
	for(i=0;i<n;i++)
	    p.addPoint(xg[i],yg[i]);
	if(ikk==0)for(i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	else for(i=0;i<n;i++){ xg[i]=(int)(xd[i]+0.49);yg[i]=(int)(yd[i]+0.49); }
	setminmax();
	xc = (xmax+xmin)/2;
	yc = (ymax+ymin)/2;
	zc = (zmax+zmin)/2;
	if(select!=0) 
	    {
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		for(i = 0;i<n;i++)
		    {
			g.setColor(Color.red);
			g2.drawLine(xg[i],yg[i],xg[(i+1)%n],yg[(i+1)%n]);
			g.fillRect(xg[i]-1,yg[i]-1,3,3);
		    }
	    }
	if(select==0 && refill==1)
	    { 
		g2.setColor(cc); 
		g2.fillPolygon(p);
		g2.setColor(cl) ;
	    }
	if(select==0)
	    {
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		g2.drawPolygon(p);
	    }
	g.setColor(cl);
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
    }

    public void metapost(BufferedWriter out) 
    {
	c=cc;
	int ny0 = 1180-yg[0]/uesc;
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
   	try 
	    {
		int sy0=1180-yg[0]/uesc;
		int sy1=1180-yg[1]/uesc;
		if((int)(10f*thickness)!=5) out.write ("pickup pencircle scaled "+thickness+";\n");

		if(refill==1)
		    {
			float cr = (float) c.getRed()/255f;
			float cv = (float) c.getGreen()/255f;
			float ca = (float) c.getBlue()/255f;

			out.write ("col:=("+cr+","+cv+","+ca+");\n"); 
			out.write("filldraw ("+(xg[0]/uesc)+"u,"+ny0+"u)--(");
			for(int i=1;i<n;i++)
			    out.write((xg[i]/uesc)+"u,1180u-"+(yg[i]/uesc)+"u)--(");                   		    out.write((xg[0]/uesc)+"u,"+ny0+"u)--cycle withcolor col;\n");
		    }
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n"); 
		out.write("draw ("+(xg[0]/uesc)+"u,"+ny0+"u)--(");
		for(int i=1;i<n;i++)
		    out.write((xg[i]/uesc)+"u,1180u-"+(yg[i]/uesc)+"u)--(");
		out.write((xg[0]/uesc)+"u,"+ny0+"u)--cycle");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		    {
			out.write(" withcolor loc");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }
		else 		
		    {
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }		    
	    }
	catch (IOException ex) { }             
	} 

    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	
	if(ikk==1)
	    for(int i=0;i<n;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		    if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		    if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
		}
	
	if(ikk==0)
	    for(int i=0;i<n;i++)
		{
		    if(xg[i]<xmin) xmin = xg[i];
		    if(yg[i]<ymin) ymin = yg[i];
		    if(xg[i]>xmax) xmax = xg[i];
		    if(yg[i]>ymax) ymax = yg[i];
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		if(ikk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ikk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ikk==0)
		    {
		xg[select-2] += xx;
		yg[select-2] += yy;
		    }
		if(ikk==1)
		    {
		xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
		    }
	    }
	if(select==1 && ikk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ikk==1)
	    for(int i=0;i<n;i++) {xd[i] += (double)xx; yd[i] += (double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		if(xx-(int)xd[i]<3 && xx-(int)xd[i]>-3 && yy-(int)yd[i]<3 && yy-(int)yd[i]>-3)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }

    public boolean selectobj(int xx,int yy)
    {
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
	if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	    {
		n--;
		return(true);
	    }
	return(false);
    }
}
