import java.io.*;
import java.lang.String.*;
import java.util.*;
import java.awt.*;
import java.awt.Cursor.*;
import java.awt.event.*;
import java.awt.event.KeyEvent.*;
import java.awt.geom.*;
import java.awt.Color.*;
import java.awt.image.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import javax.swing.text.*;
import javax.swing.text.rtf.*;
import javax.swing.filechooser.*;

//***********************************************************************

class nubj_punto extends nubj

//***********************************************************************
{
    Color c;
    int x0,y0,x1,y1,ikk=0, num=0, nn=0;
    static double tt;
    nubj_mpcircle miCir;
    nubj_linea miLinea1, miLinea2;
    nubj_oval miOval;

/* CONSTRUCTORES */

/* Constructor genrico para dibujar un punto a mano */
    nubj_punto(int x,int y, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    xd[0] = xd[1] = (double)x;
	    yd[0] = yd[1] = (double)y;
	    x0 = xmin = xmax = x;
	    y0 = ymin = ymax = y;
	    select=5;
	}

/* Constructor para crear un punto resultante de una operacin matemtica 
   con doble precisin*/
    nubj_punto(double x, double y, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    xd[0] = x; yd[0] = y;
	    select=5;
	}

/* Constructor para crear el punto medio de un segmento si el valor pasado 
por "h" es igual a 1, o los puntos extremos de un segmento si el valor
de h es igual a 2. */ 
    nubj_punto(nubj_linea l1, int h, int n, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miLinea1 = l1;
	    select = 5;
	}

/* Constructor para crear el punto de interseccin de dos lneas*/
    nubj_punto(nubj_linea l1, nubj_linea l2, int h, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    miLinea1 = l1;
	    miLinea2 = l2;
	    select = 5;
	}

/* Constructor para crear el punto centro de un crculo */
    nubj_punto(nubj_mpcircle cir, int h, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    miCir = cir;
	    select = 5;
	}

/* Constructor para crear los puntos de corte de una recta y un crculo */
    nubj_punto(nubj_mpcircle cir, nubj_linea l1, int h, int n, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miCir = cir;
	    miLinea1 = l1;
	    select = 5;
	}

/* Constructor para crear los puntos de corte de una recta y una elipse. */
    nubj_punto(nubj_oval o1, nubj_linea l1, int h, int n, nubj_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miLinea1 = l1;
	    miOval = o1;
	    select=5;
	}


    public void paint(Graphics g) 
	{
	    Graphics2D g2 = (Graphics2D) g ;
	    CSD = false;

	    if(num==1) //Punto medio de un segmento
	    {
		xd[0]=(miLinea1.xd[0]+miLinea1.xd[1])/2.;
		yd[0]=(miLinea1.yd[0]+miLinea1.yd[1])/2.;
	    }

	    if(num==2) //Puntos extremos de un segmento
	    {
		if(nn==1)
		{
		    xd[0]=miLinea1.xd[0];
		    yd[0]=miLinea1.yd[0];
		}
		else if(nn==2)
		{
		    xd[0]=miLinea1.xd[1];
		    yd[0]=miLinea1.yd[1];
		}
	    }

	    if(num==3) //Punto interseccin de dos rectas
	    {
		xd[1]=miLinea1.xd[0];xd[2]=miLinea1.xd[1];
		xd[3]=miLinea2.xd[0];xd[4]=miLinea2.xd[1];
		yd[1]=miLinea1.yd[0];yd[2]=miLinea1.yd[1];
		yd[3]=miLinea2.yd[0];yd[4]=miLinea2.yd[1];
		intersec(xd, yd);
	    }

	    if(num==4) //Punto centro de un crculo
	    {
		xd[0]=miCir.xd[0];yd[0]=miCir.yd[0];
	    }

	    if(num==5) //Puntos de corte de recta y crculo
	    {
		xd[3]=miLinea1.xd[0]; yd[3]=miLinea1.yd[0];
		xd[4]=miLinea1.xd[1]; yd[4]=miLinea1.yd[1];
		xd[2]=miCir.xd[0];yd[2]=miCir.yd[0];
		double rad = miCir.R1;
		double m = (yd[4]-yd[3])/(xd[4]-xd[3]);
		double h0=yd[3]-m*xd[3];
		double ado = h0-yd[2];
		double bdo = (2.*xd[2]-2.*m*ado)/(1.+m*m);
		double cdo = (xd[2]*xd[2]+ado*ado-rad*rad)/(1+m*m);
		double ddo = Math.sqrt(bdo*bdo-4.*cdo);
		if(nn==1)xd[0] = (bdo+ddo)/2.; 
		if(nn==2)xd[0] = (bdo-ddo)/2.;
		yd[0]=m*xd[0]+h0;
	    }

	    if(num==6) //Puntos de corte de recta y elipse
	    {
		double a = ((double)miOval.w/2.)*((double)miOval.w/2.);
		double b = ((double)miOval.h/2.)*((double)miOval.h/2.);
		double m = (miLinea1.yd[1]-miLinea1.yd[0])/(miLinea1.xd[1]-miLinea1.xd[0]);
		double h = miLinea1.yd[0]-m*miLinea1.xd[0];
		double xc = (miOval.xd[1]+miOval.xd[0])/2.;
		double yc = (miOval.yd[1]+miOval.yd[0])/2.;
		double c = h-yc;
		double d = b+a*m*m;
		double bb = (2.*a*m*c-2.*b*xc)/d;
		double cc = (b*xc*xc+a*c*c-a*b)/d;
		double dd = Math.sqrt(bb*bb-4.*cc);
		if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
		if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
		yd[0] = m*xd[0]+h;
	    }


	    x0=(int)xd[0];
	    y0=(int)yd[0];
	    xc = xd[0];
	    yc = yd[0];
	    zc = zd[0];
	    int x = x0;
	    int y = y0;
	    int w = 3;
	    int h = 3;

	    float rc = (float) cl.getRed()/255f;
	    float vc = (float) cl.getGreen()/255f;
	    float ac = (float) cl.getBlue()/255f;

	    float strokeThickness = thickness;
	    BasicStroke stroke = new BasicStroke(strokeThickness);
	    g2.setStroke(stroke);
	    g2.setColor(cl);
	 
	    if(select!=0)
	    {
		g2.setColor(Color.red);
		g2.fillRect(x0-1,y0-1,3,3);
		g.drawOval((x0-4),(y0-4), 2*4, 2*4);
	    }
	    else 
	    {
		g2.setColor(cl);
		g2.fillRect(x0-1,y0-1,3,3);
		//		g.drawOval((x0-4),(y0-4), 2*4, 2*4);
	    }
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    g2.setColor(cl);
	}

    public void metapost(BufferedWriter out) 
	{
	    float sy0 = 1180f-(float)(yd[0]/uesc);
	    float xm0 = (float)(xd[0]/uesc);
	    float th = thickness;
	    float cr=0f, cv=0f, ca=0f;
	    if(c!=null)
	    {
		cr = (float) c.getRed()/255f;
		cv = (float) c.getGreen()/255f;
		ca = (float) c.getBlue()/255f;
	    }
	    float rc = (float) cl.getRed()/255f;
	    float vc = (float) cl.getGreen()/255f;
	    float ac = (float) cl.getBlue()/255f;
	    try 
	    {
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		{
		    out.write ("loc:= ("+rc+","+vc+","+ac+");\n");
		    out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u) withcolor loc;\n");
		}       	
		else out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u);\n");
	    }
	    catch (IOException ex) { }
	}

    public void moveobj(int x,int y)
	{
	    x0 += x; xd[0] += (double)x;
	    y0 += y; yd[0] += (double)y;
	    xmin=x0-5; ymin=y0-5;
	    xmax=x0+5; ymax=y0+5;
	}

    public void movepoint(int x,int y)
	{
	    x0 += x; xd[0] += (double)x;
	    y0 += y; yd[0] += (double)y;
	    xmin=x0-5; ymin=y0-5;
	    xmax=x0+5; ymax=y0+5;
	}

    public boolean selectpoint(int x,int y)
	{
	    if(((x+5)>x0 && (x-5)<x0) && ((y+5)>y0 && (y-5)<y0)) 
	    {
		select = 2;
		return(true);
	    }  
	    return(false);
	}

    public boolean selectobj(int x,int y)
	{
	    if(((x+5)>x0 && (x-5)<x0) && ((y+5)>y0 && (y-5)<y0))
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
	{
	    if(xx0<x0 && xx1>x0 && yy0<y0 && yy1>y0)
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}


    public nubj copy(nubj_list gl)
	{
	    nubj_punto g;
	    g = new nubj_punto(x0,y0,gl);
	    g.movepoint(x1-x0,y1-y0);
	    g.select = 0;
	    return(g);
    	}

    public void transform(double xc, double yc, double zc)
	{
	    int n=1;
	    ikk=1;
	    if(value!=0)
		modi(xc,yc,zc,n);
	}

    public static void intersec(double[] xd, double[] yd)
	{
	    tt=(yd[4]-yd[3])*(xd[3]-xd[1])-(yd[3]-yd[1])*(xd[4]-xd[3]);
	    tt/=((yd[4]-yd[3])*(xd[2]-xd[1])-(yd[2]-yd[1])*(xd[4]-xd[3]));
	    xd[0]=xd[1]+(xd[2]-xd[1])*tt;
	    yd[0]=yd[1]+(yd[2]-yd[1])*tt;
	}
}
